package com.covas;


import org.jboss.logging.Logger;

import io.quarkus.runtime.ShutdownEvent;
import io.quarkus.runtime.StartupEvent;

import java.time.LocalDate;
import java.time.Month;

import javax.enterprise.context.ApplicationScoped;
import javax.enterprise.event.Observes;
import javax.inject.Inject;
import javax.transaction.Transactional;

import org.eclipse.microprofile.config.inject.ConfigProperty;


@ApplicationScoped
public class ApplicationLifeCycle {
    @Inject
    @ConfigProperty(name = "covas.schema.create", defaultValue = "true") 
    boolean schemaCreate;

    private static final Logger LOGGER = Logger.getLogger(ApplicationLifeCycle.class);

    @Transactional
    void onStart(@Observes StartupEvent ev) {
        LOGGER.info("The application has started");
        if (schemaCreate){  
            Users users = new Users();
            if(users.findByPseudo("Peter") == null){
                users.pseudo = "Peter";
                users.email = "peter@email.com";
                users.name = "Toto";
                users.firstName = "Peter";
                users.birth = LocalDate.of(1993, Month.FEBRUARY, 23);
                users.status = true;
                users.password = "toto";
                users.persist();
                LOGGER.info("Users test was created");
            } else {
                LOGGER.info("User test wasn't created");
            }
        } else {
            LOGGER.info("DB init wassn't created");
        }  
    }
    void onStop(@Observes ShutdownEvent ev) {
        LOGGER.info("The application is stopping...");
    }
    
}
